(*  Include file for PAvatar to add DESQview API functions  *)

const
  In_DV : boolean = False;

function DESQview_Version: word;
begin
  InLine($b9/$45/$44/$ba/$51/$53/$b8/$01/$2b/$cd/$21/$3c/$ff/$74/$0A/
         $89/$5e/$fe/$c6/$06/In_DV/$01/$eb/$05/$31/$c0/$89/$46/$fe);
end;
(*  Turbo 6.0 Routine:
asm
  MOV    CX,'DE'          { CX+DX to 'DESQ' (invalid date) }
  MOV    DX,'SQ'
  MOV    AX,2B01h         { Dos' set date funct. }
  INT    21H              { call dos }
  CMP    AL,0FFh          { Was it invalid? }
  JE     @No_dv           { yep, no dv }
  MOV    AX,BX            { AH=major AL=minor }
  {MOV    @Result,BX {-- Inline }
  MOV    In_DV,01h        { In_DV is true }
  JMP    @DvGv_x          { other routines }
@No_dv:
  XOR    AX,AX              { Return 0 for no DV }
  {MOV    @Result,AX {-- Inline }
@DvGv_x:
end; *)

procedure DV_Sound(freq,dur:word);
begin
  InLine($b8/$19/$10/$8b/$9e/freq/$8b/$8e/dur/$cd/$15);
end;
(*  Turbo 6.0 Routine:
asm
  MOV   AX,1019H
  MOV   BX,freq   { frequency above 20 Hz }
  MOV   CX,dur    { duration in clock ticks }
  INT   15H
end; *)

Procedure DESQview_Init;
{$IFDEF VER55}
var
  tmp : word;
{$ENDIF}
begin
  {$IFDEF VER55} tmp := {$ENDIF}DESQview_Version; { init In_DV flag }
end;

Procedure DV_Pause;
begin
 if In_DV then
  Inline($B8/$00/$10/$cd/$15);
        { MOV AX, 1000h
          INT 15h       }
end;

{ A replacement ReadKey procedure which issues a DESQview
  Pause call if no input is ready.  Works identical to the
  ReadKey function in the Crt unit.                        }

function ReadKey : char;
begin
  while not KeyPressed do DV_Pause; { give up until key ready! }
  ReadKey := Crt.ReadKey; { now get the char }
end;

